INSTALL_DIR = ${HOME}/.local

CXX = g++
#CXX_FLAGS = -DNDEBUG -O3 -funroll-loops -g -std=c++11 -Dlinux
CXX_FLAGS = -DNDEBUG -O3 -g -std=c++11 -Dlinux -ftree-vectorizer-verbose=0  -msse4a  -fopenmp -DHAVE_OMP 
# -ftree-vectorize -march=native

# Uncomment the following line to enable CUDA
#WITH_CUDA = yes

# Uncomment the following to enable MPI
#CXX = mpic++
#CXX_FLAGS = -DNDEBUG -O3 -DHAVE_MPI -std=c++11

# PAPI setup
CXX_FLAGS += -DHAVE_PAPI
LD_FLAGS += -lpapi -lgomp

# libNUMA setup
CXX_FLAGS += -DHAVE_NUMA
LD_FLAGS += -lnuma


LD_FLAGS += -lgomp
CUDA_CXX = nvcc
CUDA_CXX_FLAGS = -DNDEBUG -O3 -DHAVE_CUDA -arch sm_21
CUDA_LD_FLAGS = $(LD_FLAGS) -L/usr/local/cuda/lib64 -lcudart
